"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pclnDesignSystem = require("pcln-design-system");

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  height: 24px;\n  width: 24px;\n  svg {\n    vertical-align: top;\n  }\n\n  &:focus {\n    background-color: ", ";\n    outline: none;\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  align-items: center;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  height: 40px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var HeaderWrapper = (0, _styledComponents["default"])(_pclnDesignSystem.Flex)(_templateObject());
var Title = (0, _styledComponents["default"])(_pclnDesignSystem.Text)(_templateObject2());
var StyledCloseButton = (0, _styledComponents["default"])(_pclnDesignSystem.CloseButton)(_templateObject3(), function (props) {
  return props.theme.palette.primary.dark;
});

var ModalHeader = function ModalHeader(_ref) {
  var bg = _ref.bg,
      color = _ref.color,
      onClose = _ref.onClose,
      title = _ref.title;
  return /*#__PURE__*/_react["default"].createElement(HeaderWrapper, {
    align: "center",
    alignItems: "center",
    color: color,
    bg: bg,
    px: 3
  }, title && /*#__PURE__*/_react["default"].createElement(Title, {
    fontSize: 1,
    bold: true
  }, title), onClose && /*#__PURE__*/_react["default"].createElement(StyledCloseButton, {
    onClick: onClose,
    ml: "auto"
  }));
};

ModalHeader.displayName = ModalHeader;
ModalHeader.propTypes = {
  bg: (0, _pclnDesignSystem.deprecatedPropType)('color'),
  onClose: _propTypes["default"].func,
  color: _propTypes["default"].string,
  title: _propTypes["default"].string
};
ModalHeader.defaultProps = {
  bg: 'blue',
  color: 'white'
};
var _default = ModalHeader;
exports["default"] = _default;